function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { forwardRef } from 'react';
import { SliderContext } from './Context';
import { Platform } from 'react-native';
import { mergeRefs } from '@gluestack-ui/utils';
function SliderFilledTrack(StyledSliderFilledTrack) {
  return /*#__PURE__*/forwardRef((_ref2, ref) => {
    let {
      style,
      ...props
    } = _ref2;
    const _ref = React.useRef(null);
    const {
      isReversed,
      state,
      trackLayout,
      orientation,
      isDisabled,
      isFocused,
      isHovered,
      isPressed,
      isFocusVisible
    } = React.useContext(SliderContext);
    const getSliderTrackPosition = () => {
      if (orientation === 'vertical') {
        return isReversed ? trackLayout.height - trackLayout.height * state.getThumbPercent(0) : trackLayout.height * state.getThumbPercent(0);
      } else {
        return isReversed ? trackLayout.width - trackLayout.width * state.getThumbPercent(0) : trackLayout.width * state.getThumbPercent(0);
      }
    };
    const sliderTrackPosition = getSliderTrackPosition();
    const positionProps = orientation === 'vertical' ? {
      height: sliderTrackPosition
    } : {
      width: sliderTrackPosition
    };
    return /*#__PURE__*/React.createElement(StyledSliderFilledTrack, _extends({}, props, {
      ref: mergeRefs([_ref, ref]),
      style: {
        ...style,
        ...positionProps
      },
      states: {
        hover: isHovered,
        disabled: isDisabled,
        focus: isFocused,
        focusVisible: isFocusVisible,
        active: isPressed
      },
      disabled: isDisabled,
      focusable: Platform.OS === 'web' ? false : undefined
    }));
  });
}
export default SliderFilledTrack;
//# sourceMappingURL=SliderFilledTrack.js.map