function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { forwardRef } from 'react';
import { SliderContext } from './Context';
import { mergeRefs } from '@gluestack-ui/utils';
import { useHover } from '@react-native-aria/interactions';
function SliderTrack(StyledSliderTrack) {
  return /*#__PURE__*/forwardRef((_ref2, ref) => {
    let {
      children,
      style,
      ...props
    } = _ref2;
    const _ref = React.useRef(null);
    const {
      isHovered
    } = useHover({}, _ref);
    const {
      trackProps,
      onTrackLayout,
      isDisabled
    } = React.useContext(SliderContext);
    return /*#__PURE__*/React.createElement(StyledSliderTrack, _extends({
      onLayout: onTrackLayout,
      ref: mergeRefs([_ref, ref])
    }, trackProps, {
      style: {
        ...style
      }
    }, props, {
      isDisabled: isDisabled,
      focusable: false,
      states: {
        hover: isHovered,
        disabled: isDisabled
      },
      disabled: isDisabled
    }), children);
  });
}
export default SliderTrack;
//# sourceMappingURL=SliderTrack.js.map